#!/bin/sh

current_path=$(cd "$(dirname $0)";pwd)

cd /root/soft

yum install -y pcre-devel gd-devel

wget -c http://nginx.org/download/nginx-1.16.1.tar.gz
tar xf nginx-1.16.1.tar.gz
cd nginx-1.16.1/
./configure --prefix=/usr/local/nginx --error-log-path=/usr/local/nginx/logs/error.log --http-log-path=/usr/local/nginx/logs/access.log --user=www --group=www --with-http_ssl_module --with-http_stub_status_module --with-http_gzip_static_module --with-http_sub_module --with-pcre --with-file-aio --with-http_realip_module --with-http_image_filter_module --with-openssl=../openssl-1.1.1d --with-http_v2_module
make && make install

mkdir /usr/local/nginx/conf/vhost

cp -f $current_path/nginx.conf /usr/local/nginx/conf/nginx.conf
cp -f $current_path/mysite.conf /usr/local/nginx/conf/vhost/mysite.conf

echo "[Unit]
Description=nginx
After=network.target
[Service]
Type=forking
ExecStart=/usr/local/nginx/sbin/nginx -c /usr/local/nginx/conf/nginx.conf
ExecReload=/usr/local/nginx/sbin/nginx -s reload
ExecStop=/usr/local/nginx/sbin/nginx -s quit
PrivateTmp=false
[Install]
WantedBy=multi-user.target" > nginx.service

chmod +x nginx.service

mv nginx.service /usr/lib/systemd/system/

systemctl enable nginx
