#!/bin/sh

cd /root/soft

#安装PHP依赖的软件包
yum install -y autoconf gcc gcc-c++ wget curl curl-devel cmake libpng libpng-devel libjpeg libjpeg-devel libzip libzip-devel libxml2 libxml2-devel bzip2 bzip2-devel freetype freetype-devel libicu-devel libxslt libxslt-devel
 
#下载php7.2.28（下载地址可能有变，自己去php.net获取最新地址）
wget -c https://www.php.net/distributions/php-7.2.28.tar.gz
 
#解压
tar xf php-7.2.28.tar.gz
 
#进入源代码目录
cd php-7.2.28/
 
#配置，指定安装目录为/usr/local/php
./configure --prefix=/usr/local/php --with-config-file-path=/usr/local/php/etc --enable-bcmath --enable-fpm --enable-ftp --enable-inline-optimization --enable-intl --enable-libxml --enable-mbregex --enable-mbstring --enable-opcache --enable-pcntl --enable-shmop --enable-soap --enable-sockets --enable-sysvsem --enable-sysvshm --enable-xml --enable-zip --with-bz2 --with-curl --with-fpm-group=www --with-fpm-user=www --with-freetype-dir --with-gd --with-gettext --with-iconv-dir --with-jpeg-dir --with-libdir=lib64 --with-libxml-dir --with-mhash --with-mysqli=mysqlnd --with-openssl --with-pcre-regex --with-pdo-mysql=mysqlnd --with-png-dir --with-xmlrpc --with-xsl --with-zlib
 
#如无报错，即可执行编译（如果报错，则执行make clean清理，解决后重新make）
make
 
#编译完毕安装
make install
 
#添加php-fpm服务管理脚本
cp sapi/fpm/php-fpm.service /usr/lib/systemd/system/
 
#设置php-fpm服务开机自启动
systemctl enable php-fpm
 
#生成配置文件（如果用于生产环境则应该复制php.ini-production）
cp php.ini-production /usr/local/php/etc/php.ini
 
#进入配置文件目录
cd /usr/local/php/etc
 
#配置php-fpm
cp php-fpm.conf.default php-fpm.conf
cp php-fpm.d/www.conf.default php-fpm.d/www.conf
 
#设置默认时区
echo 'date.timezone = "Asia/Shanghai"' >> php.ini
 
#加载opcache
echo 'zend_extension=opcache.so' >> php.ini

#关闭HTTP header的php版本显示
sed -i "s/expose_php = On/expose_php = Off/g" php.ini

#配置SSL CA证书路径
echo 'openssl.cafile=/etc/ssl/certs/ca-bundle.crt' >> php.ini

#错误记录到日志文件
echo 'error_log = "/usr/local/php/var/log/error.log"' >> php.ini

chown www:www /usr/local/php/var/log/
