#!/bin/sh

current_path=$(cd "$(dirname $0)";pwd)


#检查是否已安装过mariadb，若有则删除（linux系统自带的）
s=$(rpm -qa | grep mariadb)
for i in $s
do
  rpm -e --nodeps $i
done


#检查是否已安装过mysql，若有则删除（linux系统自带的）
s=$(rpm -qa | grep mysql)
for i in $s
do
  rpm -e --nodeps $i
done

cd /root/soft

wget -c https://downloads.mysql.com/archives/get/p/23/file/mysql-5.7.28-linux-glibc2.12-x86_64.tar.gz
tar xf mysql-5.7.28-linux-glibc2.12-x86_64.tar.gz
mv mysql-5.7.28-linux-glibc2.12-x86_64 /usr/local/mysql

cd /usr/local/mysql
mkdir data
mkdir tmp
mkdir log
touch log/error.log
chown -R mysql:mysql .

yum -y install numactl

./bin/mysqld --initialize --user=mysql --datadir=/usr/local/mysql/data --basedir=/usr/local/mysql > a.log 2>&1

#提取临时密码
pass=$(tail -n 1 a.log | awk -F ': ' '{print $NF}')
rm a.log

cp $current_path/my.cnf my.cnf

cp support-files/mysql.server /etc/init.d/mysqld
chmod +x /etc/init.d/mysqld 
chkconfig --add mysqld

service mysqld start

newpass=$(head /dev/urandom | tr -dc A-Za-z0-9 | head -c 30)

sql="ALTER USER 'root'@'localhost' identified by '$newpass'"
./bin/mysql -uroot -p"$pass" --connect-expired-password -e "$sql"

service mysqld stop

#保存新密码到文件
echo "$newpass" > $current_path/mysql_new_password.log

#控制台输出新密码
echo "mysql new password: $newpass"
